#!/bin/sh

#
#
#

# for now, check the latest logs, should also be a parameter

DEBUG=0
DATE=`date +"%Y-%m-%d"`
FILE=~/var/logs.dated/forever/*.${DATE}*oper_info.log.gz
CAT=zcat

# current day

if [ "$1" = "-n" ] ; then
 FILE=~/var/log/oper_info.log
 CAT=cat
 shift
fi

[ "$1" = "-d" ] && DEBUG=1



[ $DEBUG -eq 1 ] && echo $FILE

$CAT $FILE | grep -e '\(STUDY\|OBJECT\) acquire' -e 'STUDY open' -e '\(STUDY\|SERIES\|OBJECT\) delete' | awk -vDEBUG=$DEBUG '

  {
    if(DEBUG) print "processing " $0; 
  } 

  # opens perform a compact, remove from list.
   
$8 == "open" {
    delete dirty[$11]; 
    if(DEBUG) print "deleting " $11 " (open)"
  } 
  
  # acquire may cause redundancy (if duplicate)
  # note that duplicates may exist spanning days, so safer to just add all
  # to do that, remove/comment out the count[]++ if condition 
  
$8 == "acquire" && $10 !~ "PbR.*" && $10 !~ "SRt.*" { 
    if ($7=="STUDY")
       today[$11]=1; 
       
    if (count[$10 "@" $11]++==1 || today[$11]!=1 )
    {
      dirty[$11]++ ; 
      if(DEBUG) print "adding " $11 " (" $10 ")"
    }
  } 
  
  # partial deletes also require compaction

$8 == "delete" { 
    if ($7=="STUDY")
    {
      delete dirty[$11]; 
      if(DEBUG) print "deleting " $11 " (study delete)"
    }
    else
    {
      dirty[$11]++ ; 
      if(DEBUG) print "adding " $11 " (series or object delete)"
    }
  } 
  

END { 
 for (i in dirty) print i;
}

'