<%@
	page import = "java.io.*, java.sql.*, java.util.*, java.text.Format,
			imagemed.util.*, imagemed.actions.*, imagemed.imsession.*, imagemed.types.flag.*,
			imagemed.imtables.queryqualifier.QueryQualifier, imagemed.imtables.WorklistTableParams,
			imagemed.users.*, imagemed.summaries.SummaryManager"

%><%-- ----- Helper Functions ----- --%><%!

// lock related stuff
static boolean bReentry = false;

synchronized static boolean lock() {
	if ( bReentry )
		return false;
	bReentry = true;
	return true;
}

static void unlock() {
	bReentry = false;
}
// end of lock related stuff


void checkAction( IMSession is, CacheItem actionItem, String rights, String group, boolean checkSlow ) throws IllegalAccessException, InstantiationException, IOException {
	//this will store the userID in the threadLocal session instance
	IMSession.getSession().setRegID( actionItem.user );
	// To workaround null pointer exceptions when calling a parent/child server and passing user data
	// TODO: move it to the session handling
	IMSession.getSession().regRights = rights;
	IMSession.getSession().regGroup = group;

	DcAction action = actionItem.actionClass.newInstance();
	if ( !"".equals( action.getReqRights() ) && rights.indexOf( action.getReqRights() ) == -1 ) {
		return;
	}
	is.out.println( "<B>" + action.getName() + "</B><BR>" );
	// listname.ip.ip.ip.ip.xxx

	User actionUser = new User( actionItem.user );
	action.setList( actionUser, actionItem.list );

	if( rights.indexOf( IMTypeur.RESTRICTED_QUERY_RIGHT ) == -1 ) {
		//re-check slow query
		if( checkSlow ) {
			String mesName = "slowAction-" + actionItem.user + "-" + actionItem.list + "-"+ action.getName();
			//message must be deleted, when the query is not slow!
			// because message doesn't do any deleting
			try {
		    	QueryQualifier qq = new QueryQualifier();
				String qualif = qq.qualifyFilters( new WorklistTableParams( actionUser, actionItem.list, false, true ), true, true );
		    	if( !QueryQualifier.GOOD.equals( qualif ) ) {
		    		String problem = LocalizedMessage.getCompoundMessage( "QQ_BAD_QUERY_ACTION_RUNNING", new Format[]{ null, null, null }, new Object[]{ actionItem.user, actionItem.list, action.getName() }, false );
		    		is.out.print( problem + "<BR>\n" );
					List<String> mes = new ArrayList<String>();
					mes.add( "<center>" + problem + "</center>" );
					IMMessage.createMessageByRight( mesName, mes, IMTypeur.ADMIN_RIGHT, 10000000, 1440, false );
		    	}
		    	else {
		    		IMMessage.delete( mesName );
		    	}
			}
			catch( Throwable th ) {
				Helper.defaultCatch( th );
			}
		}
	}
	
	is.out.print( "checking " + actionItem.user + "'s " + actionItem.list + "<BR>\n" );
	UserList.acquireListLock( actionItem.user, actionItem.list );
	try {
		action.checkAction( is );
	}
	catch ( Exception e ) {
		try {
			Helper.ERRORLOG( "action.jsp", "Checking/executing actions on " + actionItem.user + "'s " + actionItem.list + " list failed: " + Helper.throwable2String( e ) );
			is.out.println( Helper.throwable2String( e ) );
		}
		catch ( Exception ex ) {
		}
	}
	finally {
		UserList.releaseListLock( actionItem.user, actionItem.list );
	}
}

%><%
	if ( !lock() ) {
		Helper.INFOLOG( "action.jsp could not get lock (cannot reenter)" );
		out.println( "cannot reenter" );
		return;
	}
	try {
		Helper.INFOLOG( "action.jsp start" );
		IMSession is = new IMSession( request, response, out ); 
		is.createIMRequest( false );
		is.sessionVariables.setProperty("actionJsp", "true");

		boolean checkSlow = false;
		GregorianCalendar now = new GregorianCalendar();
		String actDate = Helper.calcDayStr( now );
		try {
			String envq = "select * from Env";
			ResultSet rs = IMEnv.getDB().createStatement().executeQuery( envq );
			if( rs.next( ) ) {
				String lastDate = rs.getString( "SLOWQUERYCHECK" );
				if( !actDate.equals( lastDate ) ) {
					checkSlow = true;
				}	
			}
		}
		catch( Throwable th ) {
			Helper.defaultCatch( th );
		}
		
		PreparedStatement psUsers = IMEnv.getDB().prepareStatement(
				"select RIGHTS,AGROUP from " + IMEnvBase.getEnv( "ACCESSTBL" ) + " where USERID=?" );

		PreparedStatement psGroups = IMEnv.getDB().prepareStatement(
				"SELECT GROUPSRIGHTS FROM " + IMEnvBase.getEnv( "GROUPSTBL" ) + " where ID=?" );

		List<CacheItem> actions = ActionCache.getActions();
		for ( CacheItem item : actions ) {
			String rights = null;
			String group = null;
			if ( "@system".equals( item.user) ) {
				rights = IMTypeur.fullRight();
				group = "Admin";
			}
			else if ( item.user.startsWith( "#" ) ) {
				// User Group
				psGroups.setString( 1, item.user.substring( 1 ) );
				ResultSet rsGroups = psGroups.executeQuery();
				if ( !rsGroups.next() ) {
					rsGroups.close();
					continue;
				}
				rights = IMTypeur.applyForcedRights( rsGroups.getString( "GROUPSRIGHTS" ), "" );
				rsGroups.close();
			}
			else {
				// Regular user
				psUsers.setString( 1, item.user );
				ResultSet rsUsers = psUsers.executeQuery();
				if ( !rsUsers.next() ) {
					rsUsers.close();
					continue;
				}
				group = rsUsers.getString( "AGROUP" );
				rights = IMTypeur.applyForcedRights( rsUsers.getString( "RIGHTS" ), group );
				rsUsers.close();
			}
			
			checkAction( is, item, rights, group, checkSlow );
		}

		Helper.DEBUG( "checking all summaries" );
		SummaryManager.checkAndRunAll( is );

		if ( checkSlow ) {		
			String envu = "update Env set SLOWQUERYCHECK='" + actDate + "'";
			IMEnv.getDB().createStatement().execute( envu );
		}
	}
	finally {
		Helper.INFOLOG( "action.jsp end" );
		unlock();
	}
%>