<%--
 * Component: cases
 *
 * Description:
 *    Returns requested document attached to a study
 *
 * Params:
 *   f - pathinfo  : looks like <study><fname>
 *                      9.8.7.6/PDF.1.2.3.4.5
 *   cTargetDevice : needs redirect to the direction of this device instead of usual
 * 
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page import="imagemed.dotcom.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.http.Range,
			imagemed.util.*, java.io.*"

%><%
	IMSession is = new IMSession( request, response, out ); 
	Syslog logger = new Syslog( "document", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	
	is.bCheckHttpsAndRedirect = false;
	if ( ! ProxyToolbox.init( is, null, logger ) ) {
		// Login was not checked originally - we may want to consider to check user session
//		if ( ! is.regOK() ) {
//			return;
//		}
	}
	
	String pathInfo = request.getParameter( "f" );
	if ( pathInfo == null )
		pathInfo = ""; 

	String targetDevice = request.getParameter( "cTargetDevice" );
	
	String study = null;
	String object = null;
	
	try {
		int n = pathInfo.indexOf( "/" );
		if ( n > 0 ) {
			study = pathInfo.substring( 0, n );
			object = pathInfo.substring( n + 1 );
		}
	}
	catch ( Throwable th ) {
	}

	if ( study == null || object == null) {
		logger.syslog( Syslog.LOG_DEBUG, "Study or object is null" );

		response.setHeader("Content-type","text/html");
		response.setStatus( 500 );
		out.println( "Invalid request" );
		return;
	}

	//CWL, showimages calling
	if ( DotcomConfig.selfDevice().isDbOnly() && targetDevice != null && !"".equals( targetDevice ) ) {
		String redirURL = RedirectToolbox.getURL( DotcomConfig.getConfig().getServerNameTowards( targetDevice ), is.regIP, null );
		if( redirURL != null ) {
			redirURL += "/cases/document.jsp?" + request.getQueryString();
			response.sendRedirect( redirURL );
			return;
		}
	}
	
	String redirHost = RedirectToolbox.getClosestRedirectHostForStudy( is, study );
	if ( redirHost != null ) {
		String redirURL = RedirectToolbox.getClosestRedirectForStudy( is, study ) + "/cases/document.jsp?" + request.getQueryString();
		response.sendRedirect( redirURL );
		return;
	}

	if ( ProxyToolbox.checkAndProxy( is, study, true ) ) {
		logger.syslog( Syslog.LOG_DEBUG, "checkAndProxy is true" );
		return;
	}

	logger.syslog( Syslog.LOG_DEBUG, "Create Response" );

	String fname = "";

	// check if the image exists and create it if doesn't exist
	try {
		boolean bReprocess = request.getHeader( "PBReprocess" ) != null;
		logger.syslog( Syslog.LOG_DEBUG, "Reprocess flag: " + bReprocess );
	
		imagemed.dcprocessing.Document doc = new imagemed.dcprocessing.Document( study, object, bReprocess );
		fname = doc.getDocumentName();
		doc.checkAndCreateDocument();
	}
	catch( Throwable th ) {
		//response.setStatus(404);
		response.setHeader( "Content-type", "text/html" );
		String msg = "<HTML>\n<HEAD><TITLE>ERROR</TITLE></HEAD><BODY><H2>File "+ fname + " not found...</H2><BR><pre>"+
				th.getMessage() + "</pre></BODY>\n</HTML>\n";
		response.setHeader( "Content-length", Integer.toString( msg.length() ) );
		out.print( msg );
		return;
	}

	response.setContentType( "application/pdf" );

	Range range = new Range( request, response );
	
	try {
		range.sendRequestedRange( fname );
	}
	catch ( Throwable t1 ) {
		// not found or other I/O error

		//response.setStatus(404);
		response.setHeader( "Content-type", "text/html" );
		String msg = "<HTML>\n<HEAD><TITLE>Not Found</TITLE></HEAD>\n<BODY><H2>File " +
				fname + " not found...</H2></BODY>\n</HTML>\n";
		response.setHeader( "Content-length", Integer.toString( msg.length() ) );
		out.print( msg );
	}

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
