<%--
 * Component: cases
 *
 * Description:
 *    Listing and manipulating user folders
 *
--%><%@
	page import="java.util.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.lists.*, imagemed.exception.*,
			imagemed.tables.*, imagemed.imtables.*, imagemed.users.*, imagemed.util.*,
			imagemed.http.IMRequest, java.text.Format"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%-- --- Functions --- --%><%!

	void proliferateFiles( String[] fileNames ) {
		for ( int i = 0 ; i < fileNames.length ; i++ ) {
			DotcomToolbox.proliferateFile( fileNames[ i ] );
		}
	}

%><%
	IMSession is = new IMSession( request, response, out );
	String parOper = is.getButtonParam( "cOper" );
	is.bRegNotNeeded = ( parOper!=null );
	if ( !is.regOK() ) {
		return;
	}
	if ( !is.bRegNotNeeded && is.regID == null ) {
		return;
	}
	IMRequest reqPar  = is.imRequest;
	String parFolder = reqPar.getVal( "cFolder" );
	String context = reqPar.m_context;
	reqPar.delProperty( "cOper" ); // this shouldn't be saved as part of the context...
	if ( context == null || context.length() == 0 ) {
		context = reqPar.backupContext();
	}
	else {
		reqPar.passAsFile( context );
	}
	String parUserId = null;
	String parFolderName = null;
	if ( parFolder != null && parFolder.length() > 0 ) {
		String[] parts = FolderToolbox.decomposeFolderName( parFolder );
		parUserId = parts[ 0 ];
		parFolderName = parts[ 1 ];
	}

	boolean isAdmin = is.hasRight( imagemed.types.flag.IMTypeur.ADMIN_RIGHT );
	User folderUser = is.getUser();

	if ( null != parUserId && !parUserId.isEmpty() ) {
		if ( !isAdmin && !parUserId.equals( is.regID ) ) {
			throw new IMGeneralException(
					LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_FOLDERS_NO_RIGHTS", new Format[] { null, null}, new Object[] { is.regID, parUserId }, true),
					"cases/folders.jsp", LocalizedMessage.getSimpleMessage( "CASES_FOLDERS_FOLDER_ERROR" ), "/cases/folders.jsp" );
		}

		folderUser = new User( parUserId );
	}

	// --- Oper ---
	if ( "Save".equals( parOper ) ) {
		// called from cases/index.jsp automatically in popUp...
		// No way to report error to the user
		FolderFile folderFile = new FolderFile( folderUser, parFolderName );
		if ( folderFile.getUserFile().prepareForWrite() ) {
			GenericUserList.saveSimple( new IMRequest( request ), folderFile );
		}
		out.println( "<script language=\"JavaScript\">window.close();</script>" );
		return;

	}
	else if ( "Delete".equals( parOper ) ) {
		if ( FolderToolbox.countFolder( parFolder ) > 0 && !"true".equals( reqPar.getVal( "cConfirmed" ) ) ) {
			throw new IMConfirmationException( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FOLDERS_NOT_EMPTY" ),
					"cases/folders.jsp", LocalizedMessage.getSimpleMessage( "CONFIRMATION" ), 
					"/cases/folders.jsp", 
					"/cases/folders.jsp?cConfirmed=true&cOper=Delete&cFolder=" + parFolder );
		}
		else {
			FolderToolbox.deleteFolder( is, parFolder );
		}
		response.sendRedirect( "folders.jsp" );
		return;
	}
	else if ( "New".equals( parOper ) ) {
		String parNewUser = reqPar.getVal( "cFolderUser" );
		String parNewFolder = reqPar.getVal( "cFolderName" );
		if ( parNewUser == null || parNewUser.isEmpty() ||
				parNewFolder == null || parNewFolder.isEmpty() ) {
			throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "GENERAL_MISSING_PARAMETER" ) + "!", "cases/folders.jsp", LocalizedMessage.getSimpleMessage( "CASES_FOLDERS_FOLDER_ERROR" ), 
					"/cases/folders.jsp" );
		}
		folderUser = new User( parNewUser );
		parFolderName = parNewFolder;
		parFolder = parNewUser + "/" + parFolderName;
		try {
			FolderToolbox.createFolder( is, parFolder );
		}
		catch ( IMException e ) {
			throw new IMGeneralException( e.getMessage(), "cases/folders.jsp", LocalizedMessage.getSimpleMessage( "CASES_FOLDERS_FOLDER_ERROR" ), 
					"/cases/folders.jsp" );
		}
	}
	else if ( "Rename".equals( parOper ) ) {
		String parNewName  = reqPar.getVal( "cNewName" ); //only at folder renaming
		try {
			FolderToolbox.renameFolder( is, parFolder, parNewName );
		}
		catch ( IMException e ) {
			throw new IMGeneralException( e.getMessage(), "cases/folders.jsp", LocalizedMessage.getSimpleMessage( "CASES_FOLDERS_FOLDER_ERROR" ), 
					"/cases/folders.jsp" );
		}
		response.sendRedirect( "folders.jsp" );
		return;
	}//EndOf Rename , EndOf Oper

	// --- Init Table without Result ---

	String thisPage = "/cases/folders.jsp";
	String thisPageMenuTab = thisPage.substring( 1 );
	TableDescriptor tdesc = new TableDescriptor( thisPage, true, true, true, false );
	TableProperties tprop = new TableProperties();

	UserFolderFieldManager fm = new UserFolderFieldManager();
	String[] defaultFields = fm.getFields();

	TableParams tparams = new TableParams( is.imRequest );
	tparams.setDefaultFields( defaultFields );
	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( 20 );
	String queryString = is.request.getQueryString();
	if ( isAdmin && ( queryString==null || "".equals(queryString) ) ) {
		Properties defFilters = new Properties();
		defFilters.setProperty( "LUSR", "~" + is.regID );
		tparams.setDefaultFilters( defFilters );
	}
	String[] defaultSort = { "a_LUSR", "a_FLDR" };
	tparams.setDefaultSort( defaultSort );

	tdesc.setFieldManager( fm );
	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );
	tdesc.setSortDepth( 3 );

	Action act[] = new Action[ 1 ];
	act[ 0 ] = new ComboAction( tdesc, ComboAction.TYPE_FOLDER, "dr" );

	Column col = new Column( new SimpleHeader( "&nbsp;" ), new ActionCell( "FLDR", act ), "FLDR" );
	tdesc.addExtraColumn( "_FIRST", col );

	TopCell topCell[] = new TopCell[ 6 ];

	topCell[ 0 ] = new TitleTopCell( tprop, LocalizedMessage.getSimpleMessage( "tabFolders" ) );
	topCell[ 1 ] = new SimpleTopCell( tprop, JSHelper.getJsButtonSLink( is, "folderop.jsp?cOper=New", "newButton", 24, 24, LocalizedMessage.getSimpleMessage( "ALT_TEXT_ADD_NEW_FOLDER" ) ) );
	topCell[ 2 ] = new SeparatorTopCell( tprop, 4 );
	topCell[ 3 ] = new FiltersTopCell( tdesc, null, false, new String[ 0 ], false );
	topCell[ 4 ] = new SortsTopCell( tdesc, null, false, false );
	topCell[ 5 ] = new PageTopCell( tprop, tparams );
	tdesc.setTopCells( topCell );

	// --- Init Table with Result ---

	UserFolderResult ufr = new UserFolderResult( tdesc, is.regID );
	tdesc.setResult( ufr );
	Table table = new Table( tdesc );%><%-- --- HTML --- --%><HTML>
<HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "tabFolders" ) %></TITLE>
<SCRIPT Language="JavaScript">
	var pageContext="<%=context%>";
</SCRIPT>
<%
	TabToolbox.writeIMpopup( is.out );
	table.printScript( tparams, is );
%>
<SCRIPT language="JavaScript">
	function Oper_( folder, oper ) {
		top.location = 'folderop.jsp?cOper=' + oper + '&cFolder=' + folder;
	}

	function Batch_( op ) {
		self.document.Batch.cOper.value = op;
		self.document.Batch.submit();
	}
</SCRIPT>
</HEAD>
<BODY>
<% 
	TabToolbox.makeTabs( is, is.tabbean, thisPageMenuTab, "White" );
%>
<CENTER>
<%
	table.printTableTop( is );
	table.print( is );
%>
</CENTER>
</BODY>
</HTML>
