<%--
 * Component: cases
 *
 * Description:
 *    Download user profile for the viewer.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page import="imagemed.util.*,java.io.*,java.sql.*, imagemed.imsession.*,java.util.*, imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!
	String toSection( String content ) {
		return "content=" + Helper.replace( Helper.replace( content, "\n", "\\n" ), "\r", "\\r" ) + "\r\n";
	}
	
	String toSection( IMProperties props ) {
		StringBuffer result = new StringBuffer( "" );
		Enumeration<?> names = props.keys();
		while ( names.hasMoreElements() ) {
			String name = (String) names.nextElement();
			String value = Helper.replace( Helper.replace( props.getProperty( name ), "\n", "\\n" ), "\r", "\\r" );
			result.append( name + "=" + value + "\r\n" );
		}
		return result.toString();
	}

%><%
	File[] CONFIGFILES;
	Set<File> NON_PROPERTIES_FILES;
	List<File> confFiles = new ArrayList<File>();
	NON_PROPERTIES_FILES = new HashSet<File>();
	// add config files here
	String confDir = IMEnvBase.getEnv( "CONF" );
	confFiles.add( new File( confDir + "/nameformat.cfg" ) );
	confFiles.add( new File( confDir + "/dateformat.cfg" ) );
	confFiles.add( new File( confDir + "/timeformat.cfg" ) );
	confFiles.add( new File( confDir + "/fieldNames.rec" ) );
	confFiles.add( new File( confDir + "/gui.conf" ) );
	confFiles.add( new File( confDir + "/institution" ) );
	confFiles.add( new File( confDir + "/fieldValues.rec" ) );
		
	File customVC = new File( IMEnvBase.getEnv( "DICOM_VAR" ) + "/mappings/global/viewer.map" );
	if( customVC.exists() ) {
		confFiles.add( customVC );
		NON_PROPERTIES_FILES.add( customVC );
	}
		
	File f = new File( confDir + "/series_description_keywords.xml" );
	confFiles.add( f );
	NON_PROPERTIES_FILES.add( f );
	
	confFiles.add( new File( confDir + "/speech_recognition.cfg" ) );
	CONFIGFILES = confFiles.toArray( new File[ 0 ] );


	IMSession is = new IMSession( request, response, out ); 

	if ( !is.regOK() ) {
		return;
	}
	String strTrail = "\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n";

	String strProfileData = ViewerProfileManager.getUserProfileData( is, IMEnvBase.getEnv( "PROFILE_FILE" ), true, null ); // in this case we get user from the session
	
	StringBuffer result = new StringBuffer( "" );
	for ( int i = 0; i < CONFIGFILES.length; i++ ) {
		if ( !CONFIGFILES[ i ].exists() ) {
			continue;
		}
		result.append( "[server\\" + CONFIGFILES[ i ].getName() + "]\r\n" );
		String content = Helper.readTextFile( CONFIGFILES[ i ].getAbsolutePath() );
		if (!NON_PROPERTIES_FILES.contains( CONFIGFILES[i] )){
			IMProperties contentPrp = new IMProperties();
			contentPrp.recRead( CONFIGFILES[ i ].getAbsolutePath() );
			if ( !contentPrp.isEmpty() ) {
				// seems to be a properties-like configfile
				result.append( toSection( contentPrp ) );
				continue;
			}
		}
		result.append( toSection( content ) );
	}
	

	// speechmike types handling
	String spmikeFilename = "spmiketypes.conf";
	String defaultSp = IMEnvBase.getEnv(  "DOWNLOAD_HOME"  ) + "/" + spmikeFilename;
	File defaultSpFile = new File( defaultSp );
	if( defaultSpFile.exists() ) {
		result.append( "[server\\" + spmikeFilename + "]\r\n" );
		String sp = ViewerProfileManager.getSpeechMikeList( defaultSp, spmikeFilename );
		result.append( sp );
	}
	
	ReleaseAndPatchInfo releaseInfo = ReleaseAndPatchInfo.getInstance();
	if( releaseInfo != null && releaseInfo.getServerVersion() != null ) {
		result.append( "[Server]\r\n" );
		result.append( "Version=" + releaseInfo.getServerVersion() + "\r\n" );
		
		/* EZNEMKELL, senki nem hasznalja (SzG)
		result.append( "Type=" + versionInfo.getServerType().getTypeName() + "\r\n" );
		String cloneDate = versionInfo.getCloneDate();
		if ( cloneDate != null ) {
			result.append( "CloneDate=" + cloneDate +"\r\n" );
		}
		*/
	}
	
	strProfileData += result.toString();

	strProfileData += strTrail;

	response.setContentType( "text/plain" );
	response.setHeader( "Content-length", Long.toString( strProfileData.length() ) );
	response.setHeader( "Pragma", "no-cache" );

	out.println( strProfileData );

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>