<%-- 
 * Component: cases
 *
 * Description:
 *  Interface for providing report time of a study for remote dotcom servers.
 *  Also locks the study if requested.
 *
 * Parameters:
 *
 *   study        Study Instance UID
 *   lock         The requested lock operation (Lock (= default), Break, CheckLock, IsLocked, Unlock)
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.util.*,imagemed.imsession.*,java.util.*,imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession(request, response, out); 

	String parStudy = request.getParameter( "study" );
	String parLock = request.getParameter( "lock" );
	if ( parLock == null )
		parLock="Lock";

	Syslog logger = new Syslog( "getreporttime", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	logger.syslog( Syslog.LOG_DEBUG, parStudy + " " + is.COOKIE.getProperty( "sessionid" ) );

	is.bCheckHttpsAndRedirect = false;
	if ( ProxyToolbox.init( is, null, logger ) ) {
		// Session parameters were proxied from parent child, regID must be set. 
		if ( is.regID == null ) {
			logger.syslog( Syslog.LOG_ERR, "No user ID was received from parent/child");
			return;
		}
	}
	else {
		// Check regular user session
		if (!is.regOK()) {
			return;
		}
	}

	if ( null == parStudy ) {
		logger.syslog(Syslog.LOG_DEBUG,"Study is null");
%>FAILED<%return;
	}

	// reg.jspi sets is.regID to null
	if (is.getRegID() == null)
		is.setRegID( "IMRegID" );
	if (is.getRegID() == null)
		is.setRegID( request.getParameter("cRegID") );
	
	if ( ProxyToolbox.checkAndProxy(is,parStudy,false) ) {
		logger.syslog( Syslog.LOG_DEBUG, "checkAndProxy is true" );
		return;
	}
	
	boolean bRight = is.regRights != null && (
		is.regRights.indexOf( "R" ) != -1 || 
		is.regRights.indexOf( "E" ) != -1 || 
		is.regRights.indexOf( "T" ) != -1 );
	
	// Lock the study
	if ( is.regID != null && is.COOKIE.getProperty( "sessionid" ) != null && bRight ) {
		if ( !"None".equals( parLock ) ) {
			Properties rspHeaders = new Properties();
			IMLock imLock = IMLock.createLocalStudyLock( parStudy, is );
			String res = imLock.localLock( parLock, rspHeaders );
		
			if ( "OK".equals( res ) ) {
				String lockID = rspHeaders.getProperty( "IMLockID" );
				if ( null != lockID )
					response.setHeader( "IMLockID", lockID );
				response.setHeader( "IMLock", "OK" );
			}
			else {
				for ( Enumeration<?> e = rspHeaders.propertyNames(); e.hasMoreElements(); ) {
					String name = ( String ) e.nextElement();
					response.setHeader( name, rspHeaders.getProperty( name ) );
				}
				response.setHeader( "IMLock", "FAILED" );
			}
		}
	}

	if ( !bRight )
		response.setHeader( "IMLock", "NORIGHT" );

	String lastModified = Report.getLastModified( parStudy );
	out.println( "LastModifiedDateTime=" + lastModified );
	logger.syslog( Syslog.LOG_DEBUG, "Session Time Zone: " + is.getTimeZone() + "/" + is.getEffectiveTimeZone() );
	logger.syslog( Syslog.LOG_DEBUG, "Last modified date/time of study report for " + parStudy + " is " + lastModified );
	if ( IMSession.getSession() != null && IMSession.getSession().getTimeZone() != null ) {
		logger.syslog( Syslog.LOG_DEBUG, "Thread Session Time Zone: " + IMSession.getSession().getTimeZone() );
	}
			
	if ( true )
		return;%>
