<%--
 * Component: cases
 *
 * Description:
 *    Managing order groups.
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.imsession.*, imagemed.jsputil.*, imagemed.exception.*, imagemed.tables.*, 
			imagemed.imtables.*, imagemed.http.IMRequest, imagemed.util.*,java.util.*, java.text.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}

	if ( is.regRights.indexOf( 'H' ) == -1 ) { // no scheduling right
		throw new IMGeneralException(
				LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_ORDERS_NO_RIGHTS", new Format[]{ null }, new Object[]{ is.regID }, true ),
				"cases/index.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_ORDERS_NO_RIGHTS_TITLE" ), "/cases/index.jsp" );
	}
	IMRequest reqPar = is.imRequest;
	String parOper = reqPar.getVal( "cOper" );
	reqPar.delProperty( "cOper" ); // cOper shouldn't be included in context
	String context = reqPar.m_context;
	if ( context == null || context.length() == 0 ) {
		context = reqPar.backupContext();
	}

	String thisPage = "/cases/orders.jsp";
	String thisTab = thisPage.substring( 1 );
	String thisPageMenuTab = thisPage.substring( 1 );
	String returningURL = reqPar.getVal( "cBack" );
	if ( returningURL == null || returningURL.length() == 0 ) {
		returningURL = Helper.URLEncodeUTF8( thisPage + "?cContext=" + context );
	}

	// --- Oper ---
	if ( "merge".equals( parOper ) ) {
		String[] pstyiuids = reqPar.getVals( "cGr" );
		// merge order groups into one group
		if ( pstyiuids == null || pstyiuids.length < 2 ) {
			throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_ORDERS_MERGE" ), thisTab,
					LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_ORDERS_MERGE_TITLE" ), thisPage + "?cContext=" + context );
		}

		boolean succesful = imagemed.dcprocessing.GroupOrders.groupOrders( is, pstyiuids );

		out.println( "<h3>" + ( succesful ? LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_ORDERS_MERGE_GROUP_SUCCESSFUL" ) : LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_ORDERS_MERGE_GROUP_ERROR" ) ) + "</h3>" );
		out.flush();
		Thread.sleep( 2000 );
		out.println( "<script language=javascript> this.location.href=\"" + thisPage + "?cContext=" + context + "\"; </script>" );
		return;
	}
	reqPar.passAsFile( context );
	// display default merge page...

	TableDescriptor tdesc = new TableDescriptor( thisPage, true, true, true, false );
	TableProperties tprop = new TableProperties();

	OrderFieldManager fm = new OrderFieldManager();

	TableParams tparams = new TableParams( is.imRequest );
	tparams.setDefaultFields( TableParams.getDefaultFields( thisPage, is ) );
	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( 20 );
	tparams.setDefaultSort( TableParams.getDefaultSorts( thisPage ) );

	tdesc.setFieldManager( fm );
	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );
	tdesc.setSortDepth( 3 );

	Result result = new OrderResult( fm, tdesc, new String[]{ "PSYU" } );

	Action act[] = new Action[ 2 ];
	act[ 0 ] = new CheckboxAction( tprop, "PSYU", "cGr", null, true );
	act[ 1 ] = new LinkAction( tdesc, "PSYU", "/cases/orderGroupSplit.jsp?cBack=" + returningURL + "&cPSTYIUID=$$PSYU$$",
			"<IMG src=\"/cases/art/more.gif\" width=19 height=17 border=none alt=\"View elements of Group\">",
			"View elements of group" );
	Properties extraPars = new Properties();
	extraPars.setProperty( "cBack", returningURL );
	act[ 1 ] = new ComboAction( tdesc, ComboAction.TYPE_ORDERGROUP, "", extraPars );


	Action batchAct[] = new Action[ 1 ];
	batchAct[ 0 ] = new LinkAction( tdesc, null, "JavaScript:Batch_(\"merge\")",
			"<IMG SRC=\"/cases/art/merge.gif\" width=\"19\" height=\"17\"" +
					" alt=\"Merge selected order groups\" border=0>",
			"Merge selected order groups" );

	Column col = new Column( new BatchHeader( batchAct ), new ActionCell( "PSYU", act ), "PSYU" );
	tdesc.addExtraColumn( "_FIRST", col );

	TopCell topCell[] = new TopCell[ 5 ];

	topCell[ 0 ] = new TitleTopCell( tprop, LocalizedMessage.getSimpleMessage( "CASES_ORDERS_ORDER_GROUPING" ) );
	topCell[ 1 ] = new FieldsTopCell( tdesc, null, false );
	topCell[ 2 ] = new FiltersTopCell( tdesc, null, false, new String[ 0 ], false );
	topCell[ 3 ] = new SortsTopCell( tdesc, null, false, false );
	topCell[ 4 ] = new PageTopCell( tprop, tparams );
	tdesc.setTopCells( topCell );

	// --- Init Table with Result ---

	tdesc.setResult( result );

	String uglyAddendum = ">\n<input type=hidden name=\"cOper\" value=\"unset\"";
	tdesc.formParams += uglyAddendum;
	Table table = new Table( tdesc );

%><%-- --- HTML --- --%><HTML>
<HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_ORDERS_ORDER_GROUPING" ) %></TITLE>
 <SCRIPT Language="JavaScript">
	var pageContext="<%=context%>";
 </script>
<%
	TabToolbox.writeIMpopup( is.out );
	table.printScript( tparams, is );
%>
  <SCRIPT language="JavaScript">

	function Batch_( op ) {
		self.document.Batch.cOper.value = op;
		self.document.Batch.submit();
	}

  </script>
</head>

<BODY>
<% 
	TabToolbox.makeTabs( is,is.tabbean, thisPageMenuTab, "White" );
%>
<CENTER>
<%
	table.printTableTop( is );
	table.print( is );
%>
</CENTER>
</BODY>
</HTML>
