<%--
 * Component: cases
 *
 * Description:
 *    Saves the viewer profile for a user.
 *
 * Parameters:
 * 
 *     USERNAME : ID of the user for the profile to be saved
 *     PROFILE  : profile data to be saved
 *
--%><%@
	page import="imagemed.util.Helper, imagemed.imsession.*, java.io.*, java.util.*,
			imagemed.jsputil.*, imagemed.users.*"

%><%!

	String filterProfile( String profile ) {
		StringBuffer result = new StringBuffer( "" );
		StringTokenizer lines = new StringTokenizer( profile, "\n" );
		boolean shouldAdd = true;
		while ( lines.hasMoreTokens() ) {
			String line = lines.nextToken();
			String trimmedLine = line.trim();
			if ( trimmedLine.startsWith( "[" ) ) { // a section starts here
				if ( trimmedLine.startsWith( "[server\\" ) || trimmedLine.startsWith( "[Server]" ) ) {
					shouldAdd = false; // hidden section starts
				}
				else {
					shouldAdd = true; // non-hidden section starts
				}
			}
			if ( shouldAdd ) {
				result.append( line + "\n" );
			}
		}
		return result.toString();
	}

%><%

	IMSession is = new IMSession( request, response, out );

	boolean profileModifiedOnServer = false;
	String strResponse = "ERROR: User not found";
	String strUserName = request.getParameter( "USERNAME" );
	String strProfileData = request.getParameter( "PROFILE" );
	String strRegCookie = is.COOKIE.getProperty( "sessionid" );

	User user = is.getUser();

	if ( strUserName != null ) {
		user = new User( strUserName );
	}

	if ( user != null && user.getId() != null && strRegCookie != null ) {
		String profileName = IMEnvBase.getEnv( "PROFILE_FILE" );

		UserFile profileFile = user.getDir().getUserFile( profileName );
		UserFile tempFile = profileFile.resolveSibling( "tmp." + profileName + "." + System.currentTimeMillis() + "." + Helper.getCounter() );

		try {
			if ( !tempFile.prepareForWrite() ) {
				throw new Throwable( "User directory does not exist" );
			}

			if ( strProfileData == null ) {
				throw new Throwable();
			}

			// test if profile has been modified by an admin or someone else
			if ( profileFile.exists() ) {
				long lProfileFile = profileFile.toFile().length();
				byte[] byteProfileBuffer = new byte[ (int) lProfileFile ];
				FileInputStream fInStream = new FileInputStream( profileFile.toFile() );
				fInStream.read( byteProfileBuffer, 0, (int) lProfileFile );
				fInStream.close();

				String profileStrOld = new String( byteProfileBuffer );

				if ( profileStrOld.indexOf( ViewerProfileManager.MODSTRING ) != -1 ) {
					profileModifiedOnServer = true;
					throw new Throwable();
				}
			}
			//test ends here

			strProfileData = Helper.replace( strProfileData, "\r\n", "\n" );
			strProfileData = filterProfile( strProfileData );

			FileOutputStream fOutStream = new FileOutputStream( tempFile.toFile() );
			fOutStream.write( strProfileData.getBytes() );
			fOutStream.close();
			
			if ( !( Helper.renameToNotThrowsException( tempFile.toFile(), profileFile.toFile() ) ) ) {
				throw new Throwable();
			}
			
			try {
				String cmd[] = new String[ 3 ];
				String env[] = new String[ 1 ];

				cmd[ 0 ] = IMEnvBase.getEnv( "DOTCOM_HOME" ) + "/proliferate.sh";
				cmd[ 1 ] = "-f";
				cmd[ 2 ] = profileFile.toString();
				Helper.runCommand( cmd, null );
			}
			catch ( Throwable th2 ) {
			}
			strResponse = "OK";
		}
		catch ( Throwable th ) {
			if ( profileModifiedOnServer ) {
				strResponse = "ERROR: Profile modified on server";
			}
			else {
				strResponse = "ERROR: Profile could not be saved";
			}
		}
		finally {
			if ( tempFile.exists() ) {
				tempFile.toFile().delete();
			}
		}
	}


	response.setContentType( "text/plain" );
	response.setHeader( "Pragma","no-cache" );
		
	out.println( "# SessionID: " + strRegCookie );
	out.println( "# Profile: " + strResponse );

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}%>