<%-- 
 * Component: cases
 *
 * Description:
 *   Quick View Window to show a DICOM image
 
 *   Quick View Window has got two parts (frames).
 *   The top is the quick view.
 *   The bottom contains DICOM dump links.
 *
 * Params:
 *    cFileName - File Name of the object to show
 *    cI          Frame Number within the object
 *    cX          Maximum X size
 *    cY          Maximum Y size
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.http.IMRequest, imagemed.util.Helper, imagemed.types.*, java.sql.*, imagemed.imsession.*, imagemed.jsputil.RedirectToolbox"

%><%
	IMSession is = new IMSession( request, response, out );

	is.bRegNotNeeded = true;
	try {
		is.regOK();
	}
	catch ( Throwable th ) {
	}
	
	boolean hasDumpRight = is.hasRight( imagemed.types.flag.IMTypeur.DUMP_RIGHT );

	IMRequest reqPar = new IMRequest( is.request );
	String cI = reqPar.getVal( "cI" );
	String cX = reqPar.getVal( "cX" );
	String cY = reqPar.getVal( "cY" );

	Statement st = IMEnv.getDB().createStatement();
	String fileName = reqPar.getVal( "cFile" );
	String study = reqPar.getVal( "cStudy" );
	
	String redirHost = RedirectToolbox.getRedirectForStudy( is, study );
	if ( redirHost != null ) {
		String redirURL = redirHost + "/cases/qvwin.jsp?" + RedirectToolbox.getRedirectParams( is );
		response.sendRedirect( redirURL );
		return;
	}
	
	String stStr = "SELECT PNAME FROM Dcstudy WHERE STYIUID='" + Helper.sqlEncode( study ) + "'";
	String pName = null;
	try ( ResultSet res = st.executeQuery( stStr ) ) {
		res.next();
		pName = res.getString( "PNAME" );
	}

	String patientName = IMType.getTypeFor( "PN" ).display( pName );

	String frameSetRows = hasDumpRight ? "*,48" : "*";
	
%><HEAD>
<TITLE><%=patientName%></title>
</head>

<FRAMESET rows="<%=frameSetRows%>" frameborder=no frameborder="0" border=0 framespacing=0>

<FRAME src="qvwintop.jsp?study=<%= study %>&fileName=<%= fileName %>&cI=<%= cI %>&cX=<%= cX %>&cY=<%= cY %>"
		noresize marginwidth=0 marginheight=0>

<%
	if ( hasDumpRight ) {
%>

<FRAME src="qvwinbot.jsp?cStudy=<%= study %>&cFname=<%= fileName %>&pName=<%= Helper.URLEncodeUTF8( patientName ) %>"
		noresize marginwidth=0 marginheight=0>
<%
	}
%>

</frameset>