<%--
 ** Component: cases
 **
 ** WEB interface for viewing/editing reports.
 **
 **  @param cGr               Study Instance UID
 **  @param cBack             URL to go back after viewing/editing reports
 **  @param cOp               Operation Mode: Edit, Approve, Save, batchApprove
 **  @param cSize             Image size for previewing key images:  None, 128x128, 256x256, 512x512
 **  @param cPrintFriendly    Print friendly page
 **  @param cDontPrint        Only takes effect in print friendly mode: don't start printing automatically
 **  @param cConfirm          Approve operation is confirmed
 **  @param cBreak            Break lock
 **  @param cTemplate					Use this template XML instead of user's or system's default
 **  @param cIntegrated				the page is used as a report edit in the viewer
 **  @param cAjaxSave					the page is used to save a report modified during batch approval
 **  @param cActingUser				The user who initiated the jsp (at print and fax)
 **
 **  @param results_sopiuid   SOP Instance UID of the results
 **  @param impression        Impression text
 ** 
 **  @param int<N>_isNew        Indicates whether a new interpretation was created
 **  @param int<N>_typeid       Interpretation typeid of the <N>. interpretation
 **  @param int<N>_sopiuid      SOP Instance UID of the <N>. interpretation
 **  @param int<N>_statid       Status ID of the <N>. interpretation
 **  @param int<N>_statid_orig  Original (previous) Status ID of the <N>. interpretation
 **  @param int<N>_author       Author of the <N>. interpretation
 **  @param int<N>_recdate_yr   Year of Recorded date of the <N>. interpretation
 **  @param int<N>_recdate_mo   Month of Recorded date of the <N>. interpretation
 **  @param int<N>_recdate_dy   Day of Recorded date of the <N>. interpretation
 **  @param int<N>_rectime_hr   Hour of Recorded time of the <N>. interpretation
 **  @param int<N>_rectime_mi   Minute of Recorded time of the <N>. interpretation
 **  @param int<N>_text         Interpretation text of the <N>. interpretation
 **  @param int<N>_birads       Birads code of the <N>. interpretation (for MG studies)
 ** 
 **  <N> is a serial number started with 0
 ** 
--%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.imsession.*, imagemed.imtables.*, imagemed.tables.*,java.io.File,
			java.util.*, imagemed.exception.*, imagemed.util.*, imagemed.types.*,
			imagemed.jsputil.*, java.sql.*, imagemed.layout.*, imagemed.layout.datasource.*,
			imagemed.types.number.IMTypeATNM, imagemed.types.date.TimeStamp, imagemed.users.*"

%><%!

	String html2psFix(String html) {
		html = Helper.replace(html, "<BR>", "<br>");
		html = Helper.replace(html, "<bR>", "<br>");
		html = Helper.replace(html, "<Br>", "<br>");
		html = Helper.replace(html, "<BR/>", "<br>");
		html = Helper.replace(html, "<bR/>", "<br>");
		html = Helper.replace(html, "<Br/>", "<br>");
		html = Helper.replace(html, "<br/>", "<br>");
		html = Helper.replace(html, "<br>", "&nbsp;<br>");
		html = Helper.replace(html, "&nbsp;&nbsp;<br>", "&nbsp;<br>");
//		html = Helper.replace(html, "<br//>", "<br>"); // the dirtiest hack ever.
//		html = Helper.replace(html, "&nbsp;<br>", "<u style=\"\">&nbsp;<br></span>");
//		html = Helper.replace(html, "<br>", "<img src=\"/cases/art/spacer.gif\" width=1 height=1><br>");
		return html;
	}

%><%
	IMSession is = new IMSession(request, response, out);
	response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
	response.setHeader("Pragma","no-cache"); //HTTP 1.0
	response.setDateHeader ("Expires", -1); //prevents caching at the proxy server

	if (!is.regOK(!"batchApprove".equals(request.getParameter("cOp")))) {
		return;
	}
	

	String parStudy = request.getParameter("cGr");
	String parActingUser = request.getParameter("cActingUser");

	if (request.getParameter( ConditionalAreaGroup.HASATTACHMENT ) == null) {
		// set the hasAttachment parameter
		try {
			is.imRequest.setProperty( ConditionalAreaGroup.HASATTACHMENT, "" + IMTypeATNM.hasAttachment( parStudy ) );
		}
		catch (Throwable th){}
	}

	String parKey = request.getParameter( "cKey" );
	String strViewSessionID = request.getParameter("ViewSessionID");
	if ( parKey == null ) {
		WorklistResult wlr = DcmLDSRecord.staticGetWLR( is, parStudy );
		if ( !wlr.isInAccessList( parStudy ) ) {
			// check if we were called by a viewer and the study is opened in the viewer and if so, give it a key
			String strVidFileName = IMEnvBase.getEnv( "LOGIN_TMP" ) + "/" + strViewSessionID + ".vid";
			File fVidFile = new File( strVidFileName );
			HashMap<String, FingerPrint> vidFingerprints = null;
			if ( fVidFile.exists() ) {
				vidFingerprints = VIDManager.readStudyFingerprintsFromVID( strViewSessionID );
				if ( vidFingerprints.keySet().contains( parStudy ) ) {
					parKey = IMKey.genStudyKey( parStudy, is._sid );
				}
			}
		}
	}

	try {
		// getRedirectForStudy() does anything only in a CWL environment on the Worklist server
		String redirHost = RedirectToolbox.getRedirectForStudy( is, parStudy );
		if ( redirHost != null ) {
			String redirURL = redirHost + "/cases/reportview.jsp?" + RedirectToolbox.getRedirectParams( is );
			if ( parKey != null && request.getParameter( "cKey" ) == null ) {
				redirURL += "&cKey="+Helper.URLEncodeUTF8( parKey );
			}
			response.sendRedirect( redirURL );
			return;
		}
	}
	catch (IMException ime) {
		Helper.DEBUG("cases/edit.jsp", Helper.throwable2String(ime));
	}
	boolean isViewer = "true".equals(request.getParameter("cIntegrated"));
	boolean isAjaxSave = "true".equals(request.getParameter("cAjaxSave"));
	if ( !ReportToolbox.initSession( is ) ) {
		// Missing study (cGr)
%><%@page import="imagemed.dotcom.DotcomConfig"%><%@
page import="imagemed.layout.macro.input.RichTextAreaInputMacro"%><HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_RV_REPORT_MISSING_DATA" ) %></title>
  <META http-equiv="Refresh" content="5; URL=/cases/index.jsp">
<%		TabToolbox.writeIMpopup(out); 
imagemed.http.tabs.TabBean.writeStyleOnly(is);%>
    </head><BODY>
<%		if (!isViewer) TabToolbox.makeTabs( is, is.tabbean, "cases/index.jsp", "White" );  %>
    <CENTER><h2><FONT face="Arial,Helvetica,Universe,Sans-Serif"><%= LocalizedMessage.getSimpleMessage( "CASES_RV_DATA_MISSING" ) %></font></h2></center>
    </body></html>
<%
		return;
	}
	String studyUID = is.sessionVariables.getProperty("study");
	if ( IMAdminToolbox.bAdminRight( is ) ) { //is admin
		UserFile settingsFile = is.getUser().getDir().getUserFile( "settings.cfg" );
		if ( settingsFile.prepareForWrite() ) {
			IMProperties.setValueInFile( settingsFile.toString(), "lastreport", studyUID );
		}
	}
  
//	Check if study exists and is accessible for the user
//	String fields[] = { "RPST", "STAT", "PANM", "PAID", "PSEX", "PDOB", "PHRF", "MODY", "ACCN", "DSCR", "SYDT" };

	String SQLtables[]     = { "Dcstudy", "Dcobject" , "" };
	IMFieldManager fm = new IMFieldManager("Dcfields", "Dctypes", SQLtables);

	TableDescriptor tdesc       = new TableDescriptor();
	WorklistTableParams tparams = new WorklistTableParams( is.imRequest, is.getUser() );

	String[] fields = null;
	String query = "select COLID from Dctables where TABLENAME='Dcstudy'";
	ResultSet resultSet = IMEnv.getDB().prepareStatement(query).executeQuery();
	List<String> fieldList = new ArrayList<String>();
	while (resultSet.next()) {
		fieldList.add(resultSet.getString("COLID"));
	}
	fields = fieldList.toArray(new String[0]);
	tparams.setDefaultFields(fields);

	Properties filters = new Properties();
	filters.setProperty("SYUI",studyUID);
	tparams.setDefaultFilters(filters);

	tdesc.setTableParams(tparams);
	tdesc.setFieldManager(fm);
	WorklistResult dbResult = new WorklistResult(is, tdesc);
	if ( parKey != null ) {
		if ( !dbResult.isInAccessList( studyUID ) ) {
			Check ch = new Check( studyUID, parKey );
			if ( ch.hasAccess( is, dbResult, false ) == null ) {
				dbResult.ignoreGlobalRestriction();
			}
		}
	}
	dbResult.setGlobal(true);
	if (!dbResult.next()) {
		throw new IMGeneralException("No such study","cases/index.jsp","Report Error",is.sessionVariables.getProperty("back"));
	}


	int nWaitTime = 30000; // 30 sec
	Properties prpLock = new Properties();
	Properties prpLastModified = null;
	String lockID = null;


	// Approve interpretation
	boolean bApproveRight = "true".equals(is.sessionVariables.getProperty("bApproveRight"));

	boolean bApprove = "Approve".equals(is.request.getParameter("cOp"));
	boolean isApprove1 = bApprove && bApproveRight;	
	boolean isApprove = ReportToolbox.checkAndDoApprove(is, prpLock, nWaitTime);
	if (isApprove1 && !isApprove) {
		// approve is finished, we should return to cases/index...
		String back  = is.sessionVariables.getProperty("back");
		is.response.sendRedirect(back);
		return;
	}

	//  Save data
	String origStudy = studyUID;
	if (isAjaxSave) {
		// check for int0_statid, if it's missing the statusinputmacro is missing which would result in corrupt/incomplete saving
		if (request.getParameter( "int0_statid" ) == null) {
			response.addHeader("ajaxSaveResult", "Mandatory parameter \"int0_statid\" missing, maybe your edit report template does not contain a statusinputmacro.");
			return;
		}
	}
	String strSaveError = ReportToolbox.checkAndDoSave(is, !isAjaxSave);
	if (isAjaxSave) {
		response.addHeader("ajaxSaveResult", strSaveError==null?"OK":strSaveError);
		return;
	}
	String newStudy = is.sessionVariables.getProperty("study", "");

	// Reports created for orders are saved with proposedStudyUID.
	// Check if the new study exists use it for showing the report
	if (!"".equals(newStudy) && !origStudy.equals(newStudy)) {
		filters = new Properties();
		filters.setProperty("SYUI", newStudy);
		tparams.setDefaultFilters(filters);
		WorklistResult dbResultNew = new WorklistResult(is, tdesc);
		dbResultNew.setGlobal(true);
	   if (dbResultNew.next()) {
			dbResult = dbResultNew;
			studyUID = newStudy;
		}
	}


	// They can't be changed via function calls from this point
	boolean bEdit  = "true".equals(is.sessionVariables.getProperty("bEdit"));
	boolean bReportRight = "true".equals(is.sessionVariables.getProperty("bReportRight"));
	boolean isEdit = bEdit && bReportRight;
	boolean isBatchApprove = "batchApprove".equals(request.getParameter("cOp"));

	boolean bNeedUnlock = !isViewer && (isEdit || isApprove || isBatchApprove);

	String pid = String.valueOf(Helper.getCounter());

	String dbStatus = dbResult.getValue("RPST", "0"); // Report Status
	if ("0".equals(dbStatus)) {
		dbStatus = dbResult.getValue("STAT", "0");  // Main Status
	}

	/*
		Parse report file
	*/

	// Parameters might be changed
	Properties results = new Properties();
	Vector<Properties> interpretations = new Vector<Properties>();
	Vector<Properties> externals = new Vector<Properties>();
	Properties newInt = null;         // for creating new interpretations
  
	int res = ReportToolbox.parseReport(is, results, interpretations, externals);
	if (res == 1) {
//		throw new imagemed.exception.IMGeneralException("Invalid report version, the report should be converted", "cases/index.jsp", "Invalid Report version", null);
	}
	else if (res > 0) {
		throw new imagemed.exception.IMGeneralException("An error occured while reading report", "cases/index.jsp", "Error reading report", null);
	}

%><%-- HTML ------------------------------------------------------------- --%><%

	String dispPName  = IMType.getTypeFor("PN").display(dbResult.getValue("PANM",""));    // Patient Name
	String dispPaID = dbResult.getValue("PAID","");
	String dispStyDate = IMType.getTypeFor("DA").display(dbResult.getValue("SYDT",""));
	String dispAccNo = dbResult.getValue("ACCN","");
	String dispRefPh  = IMType.getTypeFor("PN").display(dbResult.getValue("PHRF",""));    // Referring Physician
	String birthDate =  dbResult.getValue("PDOB","");                    // Patient Birth Date
	int bdPos = birthDate.indexOf("_");
	if (bdPos != -1) {
		birthDate = birthDate.substring(0,bdPos);
	}
	String dispDate = IMType.getTypeFor("DA").display(birthDate);

	String urlName = is.sessionVariables.getProperty("urlName");
	String urlParam = is.sessionVariables.getProperty("urlParam");

	String reportTitle = "Report - " + dispPName + " / " + dispPaID + ", " + dispStyDate + ", " + dispAccNo;
	if ( "true".equals( request.getParameter( "queryTitle" ) ) ) {
		out.println( "\n"+reportTitle );
		return;
	}
	String ieVersion = ReportFunctions.getReportPanelSetting( "ieVersion", is );
if (!ieVersion.equals("0")) {
	response.setHeader( "X-UA-Compatible", "IE="+ieVersion );
%><!DOCTYPE html>
<%} %>
<HTML>
<HEAD>
<%if (!ieVersion.equals("0")) {
%><meta http-equiv="X-UA-Compatible" content="IE=<%=ieVersion%>"><%} %>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<TITLE><%= reportTitle %></title>
  
<%
	TabToolbox.writeIMpopup(out);
	imagemed.http.tabs.TabBean.writeStyleOnly(is);
	imagemed.tables.Table.printCommonScript(is);

	if (isEdit && !isViewer && !isBatchApprove) {
		String strMessageType =  ReportToolbox.checkReportLock(is, prpLock, nWaitTime);
		if (strMessageType != null) {
			bEdit = false;
			isEdit = false; // isEdit is a shortcat for bEdit && bReportRight
			is.sessionVariables.setProperty("bEdit", "false");
			is.sessionVariables.setProperty("messageType", strMessageType);
		}
		else {
			lockID = prpLock.getProperty("IMLockID");
		}
	}

	if (lockID == null) {
		lockID = IMLock.getLockIDFromIS(is);
	}
	JSHelper.printJsInclude( out, JSHelper.JQUERY_JS );
	if (isEdit) {
		// load flexselect library
		JSHelper.printJsInclude( out, JSHelper.LIQUIDMETAL_JS );
		JSHelper.printJsInclude( out, JSHelper.FLEXSELECT_JS );
		is.out.println( StyleToolbox.getStylePart( is, "flexselect" ) );
	}
	JSHelper.printJsInclude( out, "/cases/js/ReportScripts.js" );
	JSHelper.printJsInclude( out, "/cases/js/sc.js" );
	JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
	RichTextAreaInputMacro.printIncludeAndInit(is);
	//JSHelper.printJsInclude( out, "/cases/js/sc.js" );
%>
<SCRIPT>
<%
	ReportFunctions.printJsSettings( is );
%>

	var bChanged = false;
	var needUnlock = <%= bNeedUnlock ? 1 : 0 %>; // in default unlock study when leaving page

	var submitted = false;
	
	function doSubmit(frm, mod) {
		if ( submitted ) { // prevent double clicks
			return;
		}
		submitted = true;
		try {
			updateRTEs();
		}
		catch (e){}
		needUnlock = 0;  // in case of save study should not be unlocked
		while (frm.cOp.value != mod) {
			frm.cOp.value=mod;
		}
		frm.submit();
	}

	var prevContent;
	
	var changeCount = 0;

	function doBASubmit(frm, mod) {
		// mods are 'prev', 'next', 'unapprove', 'approve', 'finish', 'cancel'
		if ( pageLoaded != true ) {
			return;
		} 
		if ( mod != "cancel" ) {
			// we might want to save
			var doAsk = mod == "prev" || mod == "next" || mod == "unapprove" || mod == "finish";
			if ( !ajaxSave(doAsk)) {
				// wanted to save, but saving failed. Do not leave the page.
				return;
			}
		}
		doSubmit(frm, mod);
	}

	function ajaxSave(doAsk) {
		var currentContent = getAllContent( true );
		if ( currentContent == prevContent || ( doAsk && !confirm( "The report has been modified. Save changes?" ) ) ) {
			return true;
		}
		if ( !popupXmlHttp ) {
			alert("Sending report failed: popupXmlHttp is null. Your browser might not be supported.");
			return false;
		}
		var post = currentContent + "&cOp=Save&cAjaxSave=true<%=is.isParentSession?"&ParentSession="+is._sid.substring(1):""%>&cChangeID=<%=System.currentTimeMillis()%>.<%=Helper.getCounter()%>_" + changeCount + "&cIMLockID=<%=lockID%>";
		popupXmlHttp.open( 'POST', "/cases/reportview.jsp?baAjaxSave=<%=Helper.URLEncodeUTF8( is.regID)%>__"+escape(navigator.userAgent), false );
		popupXmlHttp.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded' );
		popupXmlHttp.send( post );
		var response = popupXmlHttp.getResponseHeader("ajaxSaveResult");
		if ( "OK" == response ) {
			// success
			prevContent = currentContent;
			changeCount++;
			return true;
		}
		if (popupXmlHttp.status != 200) {
			response = "network communication problem [" + popupXmlHttp.status + "]: " + popupXmlHttp.statusText;
		}
		if (response == "" || response == null) {
			response = popupXmlHttp.responseText;
		}
		alert("Sending report failed: "+response);
		changeCount++;
		return false;
	}
	
	function unlockStudy() {
		<%
			String studyPart = "study="+studyUID;
			if (isBatchApprove) {
				studyPart = "cContext="+request.getParameter("cContext");
				if (is.isParentSession) {
					studyPart += "&cProxy=true";
				}
			}
		%>
		studyPart='<%=studyPart%>';
		if (needUnlock) {
			try {
				console.log( "unlocking started" );
			}
			catch (e){}
			$.ajax({
  				type: 'POST',
  				url: '/cases/unlockwindow.jsp',
  				data: studyPart+'&cIMLockID=<%=lockID+(is.isParentSession?"&ParentSession="+is._sid.substring(1):"")%>',
				async:false,
				success: function() {
					needUnlock = false;
					try {
						console.log( "unlocking succeeded" );
					}
					catch (e){}
			    },
				error: function (xhr, ajaxOptions, thrownError) {
					try {
						console.log( "unlocking failed:" );
				    	console.log(xhr.status);
				    	console.log(thrownError);
					}
					catch (e){}
				}
			});
		}
	}

	$(document).ready(function(){
		window.onbeforeunload = function(){
			unlockStudy();
		}
	});
	
	function changeSize(imgsize, dose) {
		l=imgsize.options[imgsize.selectedIndex].value; 
		if(l!="") l="cSize="+l; 
		l="<%=urlParam%>"+l;
		if(l!="") l="?"+l;
		if( dose != "" ) {
			l += "&cDose=" + dose;
		}
		document.location.href="<%=urlName%>"+l;
	}

	function changeDose(dose, imagesize) {
		l=dose.options[dose.selectedIndex].value; 
		if(l!="") l="cDose="+l; 
		l="<%=urlParam%>"+l;
		if(l!="") l="?"+l;
		if( imagesize != "" ) {
			l += "&cSize=" + imagesize;
		}
		document.location.href="<%=urlName%>"+l;
	}

	function openPrintFriendly(url) {
		if ( <%= bEdit?"true":"false" %> && window.confirm('Save your work?') )
			doSubmit(self.document.saveForm,'Save');
		window.open(url,"imw_printfriendly","resizable=yes,scrollbars,toolbar=yes,menubar=yes");
	}

	function doFocusing() {
		button = document.getElementById("defaultButton");
		if (button) {
			button.focus();
		}
	}

	<%
	{
		String parentSessionPart = "";
		String ps = is.imRequest.getVal( "ParentSession" );
		if ( ps != null && ps.length() > 0 ) {
			parentSessionPart = "&ParentSession=" + ps;
		}
	%>
	radarPanelURL = "<%=is.https_host%>/cases/radar.jsp?cStudy=" + <%=JSHelper.toJSON( studyUID + parentSessionPart )%>;
	<%
	}
	%>
	
</SCRIPT>
<%
	boolean bMessageWindow = (null != is.sessionVariables.getProperty("messageType"));
	String study       = studyUID;
	String patientName = dbResult.getValue( "PANM" );  // Patient Name
	String modality    = dbResult.getValue( "MODY" );  // Modality
	String studyDate   = dbResult.getValue( "SYDT" );  // Study Date

	boolean isWebViewer = "true".equals(is.imRequest.getVal( "isWebViewer" ));

	boolean bPrintFriendly = "true".equals(is.request.getParameter("cPrintFriendly"));

	boolean bNeedPrint = false;
	if (bPrintFriendly) { // in custom report we don't use style...
%>
    <STYLE TYPE="text/css">
    TD.deftd { font-family: arial, helvetica, universe, sans-serif; }
    TD.instname { font-family: arial, helvetica, universe, sans-serif; font-size: 10pt; font-weight: bold; }
    TD.rtitle { font-family: arial, helvetica, universe, sans-serif; font-size: 18pt; font-weight: bold; }
    P.element { margin: 0em 0em; padding-top: 0em; padding-bottom: 0.3em; font-size: 13pt; }
<%		if (!is.isMSIE()) {%>
		TD {
			font-family: arial, helvetica, universe, sans-serif;
			vertical-align: middle;
			font-size: 13pt;
		}
<%		}
%>
		</STYLE>
<%
		bNeedPrint = ! "true".equals(request.getParameter("cDontPrint"));
		if (is.bIsMSIE) {
			try {
				int p = is.ua.indexOf("MSIE ");
				if (p != -1) {
					p += 5;
					while( is.ua.charAt(p) == ' ')
						p++;
					if (is.ua.charAt(p) <= '4') {
						bNeedPrint = false;
					}
				}
			}
			catch (Throwable th) {
			}
		}

		boolean isFax = "yes".equals( is.request.getParameter("cFax") );
		String action = isFax ? "fax" : "print";
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, action );
		logEntry.setField( OperLogEntry.FIELD.USER, ( parActingUser != null && !"null".equals( parActingUser ) ? parActingUser : is.regID ) );
		logEntry.setField( OperLogEntry.FIELD.STUDY, study );
		logEntry.setField( OperLogEntry.FIELD.PNAME, patientName );
		logEntry.setField( OperLogEntry.FIELD.MODALITY, modality );
		logEntry.setField( OperLogEntry.FIELD.STUDYDATE, studyDate );
		if( isFax ) {
			logEntry.setField( OperLogEntry.FIELD.FAX_NUMBER, is.request.getParameter( "cFaxNo" ) );
		}
		logEntry.log( "reportview", 0, Syslog.LOG_INFO );

//		Syslog operLog = new Syslog("reportview", 0 , IMEnvBase.getEnv("LOG_OPER_FACILITY"));
//		operLog.syslog(Syslog.LOG_INFO, "INFO STUDY print " + is.regID + " - " +
//				study + " " + patientName + " " + modality + " - - - - - - - " + Syslog.logValue( dispStyDate ) );
	}
	else {
%>
    <STYLE TYPE="text/css">
    A { text-decoration:none; }
    TD.menu  { font-family: arial, helvetica, universe, sans-serif; font-size: 10pt;}
    TD.deftd { font-family: arial, helvetica, universe, sans-serif; }
    TD.instname { font-family: arial, helvetica, universe, sans-serif; font-weight: bold; font-size: small; }
    TD.rtitle { font-family: arial, helvetica, universe, sans-serif; font-size: large; font-weight: bold; }
<%		if (!is.isMSIE()) {%>
		TD {
			font-family: arial, helvetica, universe, sans-serif;
			vertical-align: middle;
			font-size: 13pt;
		}
<%		}
			if (isViewer || isWebViewer) {%>
			BODY {
				padding: 0px;
				margin: 0px;
			}
	<%
			}
%>
    </STYLE>
<%
	}
	String onLoad = "";
	if (bNeedPrint) {
		onLoad="addLoadEvent( window.print );";
	}
	else if (isBatchApprove) {
		onLoad="addLoadEvent( batchStartup );";
	}
%>

<Script language="JavaScript">
	<%=onLoad%>

	function cancelUnlocking() {
		studyPart='<%="cContext="+request.getParameter("cContext")+(is.isParentSession?"&ParentSession="+is._sid.substring(1)+"&RefererHost="+RedirectToolbox.getReferringHost(is):"")%>';
		jsPopup('/cases/batchReportSign.jsp?cOp=abortUnlock&'+studyPart, 'unlockwindow',false);
	}

	function batchStartup() {
		setTimeout("doFocusing()", 100);
		setTimeout("cancelUnlocking()", 5000);
		prevContent = getAllContent( true );
	}
</script>

</head>

<BODY onUnload='unlockStudy();'>

<%
if (!(isViewer || isWebViewer)) TabToolbox.makeTabs( is, is.tabbean, "cases/index.jsp", "White" ); // hmmm , false
%>
<%if (is.isCurl()) { %>
<FONT face="Arial,Helvetica,Universe,Sans-Serif">
<%}%>
<CENTER>
<%

	// print message windows if needed
	if (ReportToolbox.checkAndPrintMessageWindow(is, prpLock)) {
		return;
	}

	if (strSaveError != null) {
		newInt = new Properties();
		ReportToolbox.setPropertiesFromRequest(is, results, interpretations, newInt);

%><font color="red"><b><%= strSaveError %></b></font><br><%
	}

	if ("true".equals(is.sessionVariables.getProperty("RemoteWarning"))) {
%><b>Copies of this report exist on other servers. The state reported on the<BR>
local worklist and report will change after all copies have been updated.</b><br><%
	}


%><%-- *********************** BEGINING of REPORT table ************************ --%><%

	if (isEdit) {
%>
  <FORM action="<%=urlName%>" method=post name="saveForm">
<%
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "editreport" );
		logEntry.setField( OperLogEntry.FIELD.USER, is.regID );
		logEntry.setField( OperLogEntry.FIELD.STUDY, study );
		logEntry.setField( OperLogEntry.FIELD.PNAME, patientName );
		logEntry.setField( OperLogEntry.FIELD.MODALITY, modality );
		logEntry.setField( OperLogEntry.FIELD.STUDYDATE, studyDate );
		logEntry.log( "reportview", 0, Syslog.LOG_INFO );

//		Syslog operLog = new Syslog("reportview", 0 , IMEnvBase.getEnv("LOG_OPER_FACILITY"));
//		operLog.syslog(Syslog.LOG_INFO, "INFO STUDY editreport " + is.regID + " - " +
//				study + " " + patientName + " " + modality + " - - - - - - - "+Helper.URLEncode(dispStyDate));
	}
	else if (!bPrintFriendly) { // ! isEdit
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "viewreport" );
		logEntry.setField( OperLogEntry.FIELD.USER, is.regID );
		logEntry.setField( OperLogEntry.FIELD.STUDY, study );
		logEntry.setField( OperLogEntry.FIELD.PNAME, patientName );
		logEntry.setField( OperLogEntry.FIELD.MODALITY, modality );
		logEntry.setField( OperLogEntry.FIELD.STUDYDATE, studyDate );
		logEntry.log( "reportview", 0, Syslog.LOG_INFO );

//		Syslog operLog = new Syslog("reportview", 0 , IMEnvBase.getEnv("LOG_OPER_FACILITY"));
//		operLog.syslog(Syslog.LOG_INFO, "INFO STUDY viewreport " + is.regID + " - " +
//				study + " " + patientName + " " + modality + " - - - - - - - "+Helper.URLEncode(dispStyDate));

		String back  = is.sessionVariables.getProperty("back");
%>
    <FORM action="<%= urlName %>" name="editForm" style="display: none;">
    <%=ReportToolbox.getCommonHidden(is, "			", "edit")%>
    </FORM>
<%
	}
	String reportType = Integer.parseInt(dbStatus) < 95 ? " Preliminary" : "Final";
	if (interpretations.size() == 0 && !isEdit) {
		reportType = "Empty";
	}
	if (reportType.equals("Empty")) {
		out.println("<P><TABLE width=\"100%\" cellpadding=7 cellspacing=1 border=0>");
		ReportToolbox.printPageHeader(is, externals.size() > 0?"External":reportType);
		out.println("</TABLE>");
		if (externals.size() == 0)
			return; // no data to show
	}

//	dispResults.setProperty("reason", results.getProperty("reason", dbResult.getValue("DSCR","")));
//	dispResults.setProperty("impression", results.getProperty("impression",""));

	// Get REPORT interpretation
	is.sessionVariables.remove("pics");
	is.sessionVariables.remove("picSizes");

	int numOfInterpretations = interpretations.size();
	boolean needNewInterpretation = true;
	int reportIndex = -1;
	int intCounter = 0;

	if (numOfInterpretations > 0 || isEdit) { // || externals.size() > 0) {
		for (int i = 0; i < numOfInterpretations; i++) {
			Properties interpretation = interpretations.elementAt(i);
			boolean isFinal = ReportToolbox.processInterpretation(is, interpretation);
			needNewInterpretation = needNewInterpretation && isFinal;
			if ("REPORT".equals(interpretation.getProperty("typeid")) && reportIndex == -1) {
				reportIndex = i;
			}
		}

		Properties reportInterpretation = null;
		if (reportIndex == -1) {
//			String date = Helper.longToDateTime(System.currentTimeMillis());
			TimeStamp ts = new TimeStamp( true );
//			if ( is.getTimeZone() != null ) {
//				ts.convertTo( is.getTimeZone() );
//			}

			String name = null;
			try { 
				name = Helper.getUserName(is.regID); 
			} 
			catch (Throwable th) {
				%><!-- <%=Helper.toString(th)%> --><%
			}

			reportInterpretation  = new Properties();
			reportInterpretation.setProperty("typeid", "REPORT");
			if (name != null) {
				reportInterpretation.setProperty("author", name);
				%><!-- author name set to <%=name%> --><%
			}
			else {
				%><!-- is.regID=<%=is.regID%> --><%
			}
			reportInterpretation.setProperty( "recdate", ts.getDA() );
			reportInterpretation.setProperty( "rectime", ts.getTM() );
// 			reportInterpretation.setProperty("recdate",date.substring(0,8));
//			reportInterpretation.setProperty("rectime",date.substring(8));
			reportInterpretation.setProperty("text", "");
			if (isEdit) { %>
				<input type="hidden" name="int0_isNew" value="true">
			<%
			}
			reportInterpretation.putAll(results);
			interpretations.add(0, reportInterpretation);
			needNewInterpretation = false;
		}
		else {
			reportInterpretation = interpretations.elementAt(reportIndex);
			interpretations.removeElementAt(reportIndex);
			reportInterpretation.putAll(results);
			interpretations.add(0, reportInterpretation);
		}
		
		if (!"APPROVED".equals(reportInterpretation.getProperty("statid"))) {
			reportInterpretation.setProperty("InterpretationNum",""+intCounter);
			intCounter++;
		}

		// Process NON Report Interpretations

		for (int i = 1; i< interpretations.size(); i++) {
			Properties interpretation = interpretations.get(i);
			interpretation.setProperty("InterpretationNum","" + intCounter);
			if (!"APPROVED".equals(interpretation.getProperty("statid"))) {
				intCounter++;
			}
		}

		if ( isEdit ) {
			if ( needNewInterpretation ) {
				if ( newInt == null ) {
					newInt = new Properties();
//					String date = Helper.longToDateTime( System.currentTimeMillis() );
					TimeStamp ts = new TimeStamp( true );
//					if ( is.getTimeZone() != null ) {
//						ts.convertTo( is.getTimeZone() );
//					}
						
					String name = null;
					try { 
						name = Helper.getUserName( is.regID ); 
					} 
					catch (Throwable th) {
					}

					if ( name != null ) {
						newInt.setProperty("author", name);
					}
//					newInt.setProperty( "recdate", "20140426" );
//					newInt.setProperty( "rectime", "110000" );
					newInt.setProperty( "recdate", ts.getDA() );
					newInt.setProperty( "rectime", ts.getTM() );
					newInt.setProperty( "isNew", "true" );
					newInt.setProperty( "text", "" );
				}
				newInt.setProperty( "InterpretationNum", "" + intCounter );
				newInt.setProperty( "typeid", ( numOfInterpretations == 0 ) ? "REPORT" : "AMENDMENT" );
				interpretations.add( newInt );
			%>
				<input type="hidden" name="int<%=intCounter%>_isNew" value="true">
			<%
			}

			out.println(ReportToolbox.getCommonHidden(is, "	", "Save"));
				      
			//	String back  = is.sessionVariables.getProperty("back");

			//	Hidden fields
			//	if (back != null) {
				%><%--
      <INPUT type="hidden" name="cBack" value="<%= back %>">
  <%
//			}
  %>
      <INPUT type="hidden" name="cOp" value="Save">
      <INPUT type="hidden" name="cGr" value="<%= study %>">
      <INPUT type="hidden" name="cIMLockID" value="<%= lockID %>">--%>
      <INPUT type="hidden" name="cChangeID" value="<%="" + System.currentTimeMillis() + "." + Helper.getCounter() %>">
  <%
    		if ( results.getProperty( "res_sopiuid" ) != null ) {
    		String sopiuid = results.getProperty("res_sopiuid");
    		if (sopiuid != null) {
    	out.println("<INPUT TYPE=HIDDEN NAME=\"results_sopiuid\" VALUE=\"" + sopiuid + "\">");
    		}
    	}
    		} // if (isEdit)

    	} // if (numOfInterpretations > 0 || isEdit)
    	
    	OperatingMode mode = LayoutPart.VIEWING;
    	String layoutPart = LayoutPart.REPORTLAYOUT;
    	if (isWebViewer) {
    		layoutPart = LayoutPart.WVREPORTLAYOUT;
    	}
    	else if (isViewer) {
    		if (isEdit) {
    			layoutPart = LayoutPart.REPORTEDITLAYOUT;
    			mode = LayoutPart.VIEWEREDITING;
    		}
    	}
    	else if (isEdit) {
    		layoutPart = LayoutPart.REPORTEDITLAYOUT;
    		mode = LayoutPart.EDITING;
    	}
    	else if (bPrintFriendly) {
    		mode = LayoutPart.PRINTFRIENDLY;
    	}
    	else if (isBatchApprove) {
    		layoutPart = LayoutPart.REPORTEDITLAYOUT;
    		mode = LayoutPart.BATCHAPPROVING;
    	}
  		LayoutRoot root = imagemed.layout.cache.LayoutCache.getSystemLayout(is, layoutPart);
    	long time = System.currentTimeMillis();
    	
    	if (interpretations.size() == 0) {
    		// No report but there are externals
    		LayoutRoot cachedRoot = root;
    		root = LayoutRoot.createLayoutRoot(layoutPart);
    		root.getChildren().set(0, cachedRoot.getChildren().get(0).clone(root));
    		root.trimTreeUpToType(LayoutPart.TYPEEXTERNAL);
    	}
    	Helper.DEBUG( "reportdatasource, study:" + studyUID );
		String html = root.getHtml( "  " + ( isEdit ? "  " : "" ), mode, new ReportDataSource( is, interpretations, externals, studyUID, parKey ) );
    	long delay = System.currentTimeMillis() - time;
    	out.println("</center>\n");
    	if (bPrintFriendly) {
    		html = html2psFix(html);
    	}
    	out.println(html);
    	if (isEdit) {
  %>
  </FORM>
<%
	}
    	IMProperties guiConf = IMEnv.getConfigProperties( IMEnv.GUI_CONF );
    	boolean shouldDebug = ( "true".equals( guiConf.getProperty( "showJSDebug" ) ) || 
    			                    guiConf.getValueSet( "showJSDebug" ).contains( is.regID ) ) && isViewer;
    	if (shouldDebug) {
 		out.println("<center style=\"font-size:50%\"><a href=\"javascript:void showDEBUG();\">show/hide javascript log</a>&nbsp;&nbsp;&nbsp;<a href=\"javascript:void clearDEBUG();\">clear javascript log</a></center>");
    	}
 	if (is.isCurl()) {
%>
</FONT>
<%}%>
<!-- <br>
<a href=javascript:alert(getAllContent())>test getInputValues</a>
&nbsp;&nbsp;&nbsp;<a href=javascript:alert(escape(getInputFieldContent(getFocusedFieldName())))>getInputFieldContent</a>
&nbsp;&nbsp;&nbsp;<a href=javascript:alert(getInputFieldContent(getFocusedFieldName()))>getText</a>
&nbsp;&nbsp;&nbsp;<a href=javascript:alert(getTweakedPlainText(getFocusedFieldName()))>getTweakedPlainText</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(getFocusedFieldName());">getFocusedElement</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:scrollToField('int0_text' );">scrollToField</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(getSelectionStart(getFocusedFieldName())+'-'+getSelectionEnd(getFocusedFieldName()));">get selection</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(getElementSelectionTest(returnRTE(getFocusedFieldName())));">get selection test</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(escape(getSelectedText()));">get selection content</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(getPreRangeText());">get preRange content</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void replaceSelection( getFocusedFieldName(), prompt('text', ''));">replace selection</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void replaceSelection( getFocusedFieldName(), '\n');">replace selection with NL</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void setSelection(getFocusedFieldName(), prompt('from',0), prompt('to',0));">set selection</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void checkSize(null,getFocusedFieldName());">check size</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void pbjs.testme();">test pbjs.testme()</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void alert(eval(prompt('javascript code:')));">eval JS code</a>
&nbsp;&nbsp;&nbsp;<a href="edit.html">edit.html</a>
&nbsp;&nbsp;&nbsp;<a href="divTest.html">testDiv.html</a>
&nbsp;&nbsp;&nbsp;<a href="testUndoIframe.html">testUndoIframe.html</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void document.execCommand('undo', false, null)">UNDO</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void toggleEntertainment()" id="entertainmentToggler">toggleEntertainment</a>
<br>-->
<script>

//writeRichText('impresssion', 'putty', '', '100%', true);
function sleep(miliseconds) {
	var currentTime = new Date().getTime();
    while (currentTime + miliseconds >= new Date().getTime()) {
    }
};
       
var isEntertaining = false;
function toggleEntertainment() {
	isEntertaining = !isEntertaining;
	if (isEntertaining) {
		entertain();
	}
	document.getElementById("entertainmentToggler").style.backgroundColor=isEntertaining?"green":"";
};

function entertain() {
	if (!isEntertaining) {
		return;
	}
	sleep(100);
	setTimeout(entertain, 900);
}

function getSelectedText() {
	var txt = getInputFieldContent(getFocusedFieldName());
	var sel = getFieldSelection(getFocusedFieldName());
	return txt.substring(sel[0], sel[1]);
};

function getPreRangeText() {
	var element = returnRTE(getFocusedFieldName());
	element.focus();
	var sel = window.getSelection();
	var range = sel.getRangeAt( 0 );
	var res = getTextDom( element, new RangeBoundary( range.startContainer, range.startOffset ) );
	return escape(res)+" "+res.length;
};

function pitty() {
	var Editor = frames['testFrame'];
	alert(Editor);
	var window = Editor.window;
	alert(window);
	var document = window.document;
	alert(document);
	document.designMode = "On";
	try {
		Editor.execCommand( "styleWithCSS", 0, false );
	} catch ( e ) {
		try {
			Editor.execCommand( "useCSS", 0, true );
		} catch ( e ) {
			try {
				Editor.execCommand( 'styleWithCSS', false, false );
			} catch ( e ) {
				// alert( "Setting editor to non-css mode failed. (" + e + ")"
				// );
			}
		}
	}
	
}
// var testText = document.getElementById('testText');
//if ( testText.addEventListener ) {
// testText.addEventListener( 'keyup', function() {
// alert( "testText" );
// }, false );
// } else if ( testText.attachEvent ) {
// testText.attachEvent( 'onkeyup', function() {
// alert( "testText" );
// } );
// }
// testText.onkeyup = function() {
// alert( "testText" );
// };

var testBackup = "";

function backup() {
	testBackup = getAllContent();
	return false;
}

function restore() {
	setInputValues(testBackup);
	return false;
}

function testme() {
	if (typeof(pbjs) != 'undefined') {
		pbjs.testme();
	}
}


function getScrollPositionYTest() {
	alert([document.body.scrollTop, window.pageYOffset]);
	if ( typeof document.body.scrollTop != 'undefined' ) {
		return document.body.scrollTop
	}
	return window.pageYOffset;
};


function getElementSelectionTest( element ) {
	DEBUG( "called getElementSelection(" + element + ")" );
	// The current selection
	var fullText = getText( element );
	if ( document.activeElement == element ) {
		return;
	}
	var x = getScrollPositionX();
	var y = getScrollPositionYTest();
	element.focus();
	setScrollPosition( x, y );
	return [y, getScrollPositionY()];
	focusWithoutScrolling( element );
	if ( !dontUseHTML5SelectionMode && document.getSelection ) {
		// the html5 way
		var sel = window.getSelection();
		var range = sel.getRangeAt( 0 );
		var begin = getTextDom( element, new RangeBoundary( range.startContainer, range.startOffset ) ).length;
		var end = getTextDom( element, new RangeBoundary( range.endContainer, range.endOffset ) ).length;
		return [ begin, end ];
	}
};


//addLoadEvent(testme);
<%if (shouldDebug) {%>    		
shouldDEBUG = true;
DEBUG();
<%}%>
</script>
</body>
</html>
