<%--
 * Component: cases
 *
 * Description:
 *  This page allows the support users to put a final interpretation back to the preliminary state.
 *
 * Parameters:
 *
 *   cSOPIUID          SOPIUID of the final interpretation in question
 *                 OR
 *   cStudy            STUDYIUID of the final interpretation in question
 *   cFile             filename of the interpretation
 *   cIntID            InterpretationID of the interpretation
 *   cReason           a non-empty reason must be given to explain the action
 *
 * Last Updated     : $Author $
 * Update Date Time : $Date $
 * RCS File Name    : $RCSfile $
 * RCS Revision     : $Revision $
 * Locked by        : $Locker $
 * Symbolic name    : $Name $
 * State            : $State $
 *
--%><%@
	page import="imagemed.exception.*, imagemed.imsession.*, imagemed.util.*, java.util.*, java.sql.*, java.text.Format, imagemed.jsputil.ReportToolbox"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"
	
%><%
	String parBack = request.getParameter( "cBack" );
	if ( parBack == null )
		parBack = request.getHeader( "REFERER" );
	
	IMSession is = new IMSession( request, response, out ); 

	is.regDest = parBack;

	if ( !is.regOK() ) {
		return;
	}

	if ( is.regRights.indexOf( '@' ) == -1 && is.regRights.indexOf( 'A' ) == -1 ) {
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_UNFINAL_NO_RIGHTS" ),
				"cases/index.jsp", LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_UNFINAL_ERROR" ), parBack);
	}

	if ( request.getParameter( "cSOPIUID" ) == null ) {
		// confirmed, do the stuff
		boolean isProxy = "true".equals( request.getParameter( "cProxy" ) );

		String study = request.getParameter( "cStudy" );
		String fileName = request.getParameter( "cFile" );
		String intID = request.getParameter( "cIntID" );
		String reason = request.getParameter( "cReason" );
		boolean isSucceeded = false;
		if ( study == null || study.length() == 0 || fileName == null || fileName.length() == 0 ||
				reason == null || reason.length() == 0 || intID == null || intID.length() == 0) {
			Helper.ERRORLOG( "unfinal.jsp", "unfinal.sh call parameter missing: study=" + study + ", fileName=" + fileName + ", intID=" + intID + ", reason=" + reason );
		}
		else {
			isSucceeded = Boolean.TRUE.equals( ReportToolbox.rmiUnfinalReport( null, study, fileName, reason, is.regID ) );
		}

%><HTML>
	<HEAD>
		<meta http-equiv="Refresh" content="5; URL=<%= parBack %>">
		<TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_UNFINAL_INTERPRETATION" ) %></TITLE>
<%
		imagemed.tables.Table.printCommonScript( is );
%>
	</HEAD>
	<body>
<%
		imagemed.jsputil.TabToolbox.makeTabs( is,is.tabbean, "cases/index.jsp", "White");

		MessageBox messageBox = new MessageBox( LocalizedMessage.getSimpleMessage( "CASES_UNFINAL_INTERPRETATION" ), "75%" );
		String unfinalResult = LocalizedMessage.getSimpleMessage( isSucceeded ?  "CASES_UNFINAL_RESULT_SUCCEEDED" : "CASES_UNFINAL_RESULT_FAILED" );
		
		messageBox.setMessage( "<br><H1>" + unfinalResult + "</H1><br>" );
		messageBox.addButton( new Button( parBack, "BUTTON_OK", "BUTTON_NULL" ) );

		out.println( "<BR><center>" );
		messageBox.print( is.out );
		out.println( "</center>" );
		return;
	}

	
%><HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_UNFINAL_INTERPRETATION" ) %></TITLE>
		<SCRIPT language="Javascript">
				<!-- hide the follows 
				function checkForm() {
					if (document.forms[0].cReason.value=='') {
						alert("You must enter an explanation.");
						return false;
					}
					return true;
				}
				//  unhide the follows --> 
			</SCRIPT>
<%
	imagemed.tables.Table.printCommonScript( is ); 

%></head><body>
<%
	imagemed.jsputil.TabToolbox.makeTabs( is,is.tabbean, "cases/index.jsp", "White");
	
	String sopiuid = request.getParameter( "cSOPIUID" );
	String study = null;
	String fileName = null;
	String intID = null;
	ResultSet rs = IMEnv.getDB().createStatement().executeQuery(
		"select r.SRCSTUDY, FNAME, INTID from Dcreport r, Dcobject o where r.SOPIUID=o.SOPIUID AND r.INTSOPIUID='" + sopiuid + "'" );
	if ( rs.first() ) {
		study = rs.getString( "r.SRCSTUDY" );
		fileName = rs.getString( "FNAME" );
		intID = rs.getString( "INTID" );
	}
	else {
		throw new RuntimeException( LocalizedMessage.getCompoundMessage( "DELETE_ADDENDUM_ILLEGAL_SOPIUID", new Format[] { null }, new Object[] { sopiuid }, true) );
	}
//	String postData = "cStudy=" + Helper.URLEncode(study);
//	postData += "&cFile=" + Helper.URLEncode(fileName);
//	postData += "&cReasone=" + Helper.URLEncode(reason);

	StringBuffer form = new StringBuffer();

 	form.append( "<FORM NAME=\"unfinalForm\" METHOD=\"POST\" ACTION=\"/cases/unfinal.jsp\" onSubmit=\"return checkForm();\">\n" );
	form.append( "<input type=hidden name=\"cStudy\" value=\"" ).append( Helper.htmlEncode( study ) ).append( "\">\n" );
	form.append( "<input type=hidden name=\"cFile\" value=\"" ).append( Helper.htmlEncode( fileName ) ) .append( "\">\n" );
	form.append( "<input type=hidden name=\"cIntID\" value=\"" ).append( Helper.htmlEncode( intID ) ).append( "\">\n" );
	form.append( "<input type=hidden name=\"cBack\" value=\"" ).append( Helper.htmlEncode( parBack ) ).append( "\">\n" );

	String referrerHost = is.getReferrerHost( true );
	if ( referrerHost != null ) {
		form.append( "<input type=hidden name=\"RefererHost\" value=\"" ).append( Helper.htmlEncode( referrerHost ) ).append( "\">\n" );
	}

	form.append( "<textarea name=\"cReason\" cols=\"50\" rows=\"6\"></textarea>\n" );

	form.append( "</FORM>\n" );

	MessageBox messageBox = new MessageBox( LocalizedMessage.getSimpleMessage( "CONFIRM" ), "75%" );
	messageBox.setMessage(
		"<br>" +
		"<h1> " + LocalizedMessage.getSimpleMessage( "CASES_UNFINAL_EXPLANATION_UNFINALIZING" ) + "</h1>" + 
		"<br>" +
		"<nobr>" +
		form );
	
	Button continueButton = new Button( "javascript:self.document.unfinalForm.submit();", "BUTTON_CONTINUE", "BUTTON_NULL" );
	Button cancelButton = new Button( parBack, "BUTTON_CANCEL", "BUTTON_NULL" );

	messageBox.addButton( continueButton );
	messageBox.addButton( cancelButton );

	out.println( "<center>" );
	out.println( "<br>" );
	messageBox.print( is.out );
	out.println( "</center>" );

%>
</body>
</html>
